#
# spec file for package pure-ftpd (Version 1.0.22)
#
# Copyright (c) 2010 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild


Name:           pure-ftpd
BuildRequires:  mysql-devel openldap2-devel pam-devel postgresql-devel
Version:        1.0.22
Release:        0.14.1
Url:            http://www.pureftpd.org
Source:         ftp://ftp.pureftpd.org/pub/%{name}/releases/%{name}-%version.tar.bz2
Source1:        %{name}.init
Source2:        %{name}.pamd
Source3:        %{name}.xinetd
Source4:        %{name}.xml
Patch:          %{name}-1.0.20_config.patch
Patch1:         %{name}-1.0.20_doc.patch
Patch2:         %{name}-1.0.20_virtualhosts.patch
Patch4:         %{name}-1.0.20_config_minuid.patch
Patch5:         %{name}-1.0.20_ftpwho_path.patch
Patch6:         pure-ftpd-apparmor.patch
Patch7:         pure-ftpd-1.0.22-default_tcp_sedrcv_buffer_size.patch
Patch8:         pure-ftpd-1.0.21-portrange.patch
Patch100:       pure-ftpd-1.0.22-oes_remote_server.patch
#PATCH-FIX-OES: 643981,644735,644415 and 534424
Patch101:       pure-ftpd-1.0.22-oes-bugfix.patch
Group:          Productivity/Networking/Ftp/Servers
License:        BSD 3-Clause
Provides:       ftp-server pureftpd
PreReq:         %insserv_prereq
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
Summary:        A Lightweight, Fast, and Secure FTP Server
PreReq:         coreutils

%description
Pure-FTPd is a fast, production-quality, and standard-conforming FTP
server, based-on Troll-FTPd. Unlike other popular FTP servers, it has
no known security flaws, is trivial to set up, and is especially
designed for modern Linux kernels (setfsuid and sendfile capabilities)
. Features include: PAM support, IPv6, chroot()ed home directories,
virtual domains, built-in LS, anti-warez system, bandwidth throttling,
FXP, bounded ports for passive downloads, upload and download ratios,
Apache log files, and more.



%prep
%setup -q
%patch
%patch1
%patch2
%patch4
%patch5
%patch6 -p2
%patch7
%patch8
%patch100 -p0
%patch101 -p0

%build
CFLAGS="%{optflags} -DLDAP_DEPRECATED -fstack-protector"
%configure \
	--sysconfdir=%{_sysconfdir}/%{name} \
	--with-ldap \
	--with-paranoidmsg \
	--with-altlog \
	--with-virtualhosts \
	--with-ftpwho \
	--with-mysql \
	--with-nonalnum \
	--with-pgsql \
	--with-cookie \
	--with-throttling \
	--with-ratios \
	--with-uploadscript \
	--with-diraliases \
	--with-pam \
	--with-puredb \
	--with-sysquotas \
	--with-quotas \
	--with-inetd \
	--with-tls \
	--with-boring \
        --with-peruserlimits \
        --with-rfc2640 \
	--with-largefile %_target_cpu-suse-linux
%{__make}
cat configuration-file/pure-config.pl |grep -v "^print" | grep -v "^exec" > configuration-file/pure-config-args
echo "print join(\" \", @flg);" >> configuration-file/pure-config-args

%install
%makeinstall
%{__install} -dD -m 0755 \
    %{buildroot}%{_sysconfdir}/{init.d,%{name},%{name}/vhosts,pam.d,xinetd.d,openldap/schema}
%{__install} -m 0755 \
        configuration-file/pure-config.pl \
		configuration-file/pure-ftpd-stop.pl \
        configuration-file/pure-config-args \
    %{buildroot}%{_sbindir}
%{__install} -m 0644 configuration-file/pure-ftpd.conf \
               %{buildroot}%{_sysconfdir}/%{name}
%{__install} -m 0755 %{S:1} %{buildroot}%{_sysconfdir}/init.d/%{name}
ln -sf /etc/init.d/%{name}  %{buildroot}%{_sbindir}/rc%{name}
%{__install} -m 0644 %{S:2}          %{buildroot}%{_sysconfdir}/pam.d/pure-ftpd
%{__install} -m 0644 %{S:3}          %{buildroot}%{_sysconfdir}/xinetd.d/pure-ftpd
%{__install} -m 0644 pureftpd.schema %{buildroot}%{_sysconfdir}/openldap/schema/
%{__install} -d						 %{buildroot}%{_datadir}/omc/svcinfo.d/
%{__install} -m 0644 %{S:4}			 %{buildroot}%{_datadir}/omc/svcinfo.d/
%{__install} -d                      %{buildroot}%{_sysconfdir}/apparmor/profiles/extras/
%{__install} -m 0644 usr.sbin.pure-ftpd %{buildroot}%{_sysconfdir}/apparmor/profiles/extras/

%clean
%{__rm} -rf "%{buildroot}"

%preun
%stop_on_removal %{name}

%post
if [ -f etc/pure-ftpd.conf ]; then
        mv etc/pure-ftpd.conf etc/pure-ftpd/pure-ftpd.conf
fi

%postun
%insserv_cleanup
%restart_on_update %{name}

%files
%defattr(-, root, root)
%{_datadir}/omc/svcinfo.d/%name.xml
%doc AUTHORS CONTACT COPYING NEWS THANKS README README.* HISTORY
%doc pureftpd-ldap.conf
%{_mandir}/man8/*
%{_bindir}/*
%{_sbindir}/*
%dir %{_sysconfdir}/openldap
%dir %{_sysconfdir}/openldap/schema
%dir %{_sysconfdir}/%{name}
%dir %{_sysconfdir}/%{name}/vhosts
%config %{_sysconfdir}/openldap/schema/pureftpd.schema
%config %{_sysconfdir}/init.d/pure-ftpd
%config %{_sysconfdir}/pam.d/pure-ftpd
%config(noreplace) %{_sysconfdir}/%{name}/pure-ftpd.conf
%config(noreplace) %{_sysconfdir}/xinetd.d/pure-ftpd
%dir %{_sysconfdir}/apparmor/
%dir %{_sysconfdir}/apparmor/profiles/
%dir %{_sysconfdir}/apparmor/profiles/extras
%config %{_sysconfdir}/apparmor/profiles/extras/
%{_datadir}/omc/svcinfo.d/%name.xml

%changelog
* Thu Nov 11 2010 mvyskocil@suse.cz
- fix bnc#643981: pure-ftpd remote server access problem with novfsd and
  case-sensitivity
- fix bnc#644735: pure-ftpd: SIZE command fails, using full path which
  specifies remote server access
- fix bnc#644415: pure-ftpd and remote ncp volumes: "ls subdir" causes working
  directory confusion
- the updated pure-ftpd-1.0.22-oes-bugfix-534424.patch including fxes for bugs
  above has been renamed to pure-ftpd-1.0.22-oes-bugfix.patch
* Fri Oct  8 2010 mvyskocil@suse.cz
- fix bnc#638626:  pure-ftpd is not compiled with "--with-rfc2640" for charset support
* Thu Oct  7 2010 mvyskocil@suse.cz
- fix bnc#534424 - FTP-RSN: Site slist doesn't list server count as in netware
  pure-ftpd-1.0.22-oes-bugfix-534424.patch
  * site slist display same as netware
  * fix some hangs of site slist
  * fix FTP server crash issue for the command 'cd ///'
* Fri Feb 19 2010 mseben@novell.com
- modified portrange.patch - for PassivePortRange option in pure-ftpd.conf
  we could use now also syntax without colon (bnc#547578)
* Mon Feb  8 2010 mseben@novell.com
- Update OES remote server patch (from Sujo Varghese) (bnc#569738)
* Wed Sep  2 2009 hvogel@suse.de
- Update OES remote server patch (from Sujo Varghese)
* Fri Jul 31 2009 kukuk@suse.de
- Update OES remote server patch (from Sujo Varghese)
* Fri Jul 10 2009 kukuk@suse.de
- Update OES remote server patch (from Sujo Varghese)
* Mon Jun 29 2009 kukuk@suse.de
- Fix missing protoype warnings in OES remote server patch
  (from Sujo Varghese)
* Mon Jun 29 2009 kukuk@suse.de
- Update pure-ftpd-1.0.22-oes_remote_server.patch (from Sujo Varghese)
* Mon May 25 2009 hvogel@suse.de
- Update to version 1.0.22
  - New catalan translation
  - TLS support for LDAP
  - Fix usage of MySQL 5 stored procedures
  - Compatibility with newer OpenLDAP versions
  - Don't hang up during uploads if we get any other command than QUIT and
  ABORT.
  - SITE UTIME reads UTC time
  - A space is needed for inline content in response to the MLST command.
  - Time zone issues should be fixed for good. We have to redefine TZ,
  tzset() is not enough on Linux when we are in a chroot environment.
  - Correctly respond to FEAT without removing extra features when passive
  mode is disabled. Thanks to upb.
  - Better process name change setup for Linux.
  - Auto-created home directories are now created with mode 0777 (and
  directory umask is applied), per common request. It's very important to
  double check your umask.
  - Extend gid / uid to 10 digits in ls output. Extend file size as well.
  - Brazilian portuguese translation was updated.
  - Fix SecureFX compatibility.
  - Use PQescapeStringConn() for PostgreSQL instead of hand-made escaping.
  - Don't respond to server that an upload succeeded before the temporary
  file has been renamed.
  - TLS support on data channels
  - Use sendfile() on recent Solaris versions in place of sendfilev().
  - Don't use a deprecated interface for Bonjour registration.
  - Tell authentication handlers if the connection is encrypted or not,
  through a new AUTHD_ENCRYPTED environment variable.
  - Create all directories, not only the basement when on-demand directory
  creation is enabled and the user's home directory looks like /basement/./user.
  - Fixed error reporting when TLS support was compiled in, but TLS wasn't
  enabled on the current session
  - Log full path on file deletion
  - Handle "ftp" and "anonymous" like normal accounts (with passwords) if -E
  (no anonymous logins) is specified. Thanks to Arkadiusz Miskiewicz.
  - Sleep before answering a password failure, not the other way round
  - In broken mode, show symlinks as their real target. It can have side
  effects, don't forget that broken mode is... broken mode.
  - Respect aliasing rules for sockaddr_storage usage.
  - Privsep is enabled by default in the installation GUI.
  - --with-everything now includes privsep.
  - update: fix compilation with gcc 2.x
* Mon May 11 2009 hvogel@suse.de
- FATE#305671 implement remote_server for OES
* Mon May  4 2009 hvogel@suse.de
- FATE#303561 enable per-user-limits
* Mon Jan 22 2007 mskibbe@suse.de
- fix path to Apparmor profile
* Thu Jan 18 2007 mskibbe@suse.de
- AppArmor profile for Pure-FTPd (#232779)
* Thu Jan 11 2007 mskibbe@suse.de
- change path to service xml document (fate #301713 )
* Mon Jan  8 2007 mskibbe@suse.de
- add service xml document (fate #301713 )
* Mon Apr 10 2006 mrueckert@suse.de
- added pure-ftpd-1.0.20_config_minuid.patch:
  * configuration-file/pure-ftpd.conf.in: our ftp user has uid 40.
    if you want to map virtual users to this uid they would be
    blocked from login.
- added pure-ftpd-1.0.20_ftpwho_path.patch:
  * src/ftpwho-update.h: PAGE_SIZE is a function on
    glibc-2.4/kernel-2.6.16 on ppc64. use PATH_MAX for the filename
    member of the FTPWhoEntry_ struct
* Wed Jan 25 2006 mls@suse.de
- converted neededforbuild to BuildRequires
* Mon Jan 16 2006 hvogel@suse.de
- Patch from Patrick Gosling to handle transfer aborts during file
  upload correctly. [#133452]
* Fri Jan 13 2006 hvogel@suse.de
- Make use of Stack Protector
* Mon Oct 24 2005 mrueckert@suse.de
- cleaned up spec file
- add /etc/pure-ftpd/vhosts as base dir for virtual servers.
  (documentation and code changed accordingly.)
- fixed paths in the documenation
* Thu Oct 13 2005 hvogel@suse.de
- Build with DLDAP_DEPRECATED untill upstream applied one of the
  various ldap patches floating around on the sf.net project page
* Wed Aug 24 2005 hvogel@suse.de
- disable "funny" ftp messages to be a bit more professional
* Mon Nov  8 2004 kukuk@suse.de
- Use common-* PAM config files for pure-ftpd PAM configuration
* Thu Aug 12 2004 mmj@suse.de
- Use --with-diraliases
* Thu Aug 12 2004 mmj@suse.de
- Update to 1.0.20 which fixes compatibility issues.
* Wed Jun 23 2004 mmj@suse.de
- Update to 1.0.19 including:
  o Real disk space is no more shown.
  o A possible denial of service when too many users were connected
    should be fixed.
* Tue Mar  2 2004 mmj@suse.de
- Reflect in the configuration file that /etc/pure-ftpd/ now is a
  place to keep all the pure-ftpd configuration files.
* Tue Mar  2 2004 mmj@suse.de
- Move configuration file when updating
- Fix initscript to use /etc/pure-ftpd/pure-ftpd.conf [#35196]
- Update to 1.0.18 including:
  o UTF-8 characters are now supported in file names [#34829]
  o Buglets were fixed in the documentation.
  o Two new translations were added : hungarian and catalan
  o The server now uses distinct IPv4 and IPv6 to listen to both
    protocols on all operating systems. A new switch, -6, forces the
    server to only listen to IPv6.
  o W3C and CLF alternative log formats are now more standard
    conformant.
  o Pure-FTPd can now produce WU-FTPd (xferlog) compatible log files.
  o Support for Rendezvous was added on MacOS X.
  o Support for Apple / GNUStep plist data output was added to
    pure-ftpwho.
* Fri Feb 27 2004 mmj@suse.de
- Enable mysql and postgresql support, since they provide very
  good functionality with only tiny extra dependencies
- Compile with --with-nonalnum to support non alphanumeric chars
* Fri Jan 16 2004 kukuk@suse.de
- Add pam-devel to neededforbuild
* Thu Dec  4 2003 mmj@suse.de
- Update to pure-ftpd v. 1.0.17a
* Wed Oct 15 2003 mmj@suse.de
- Don't build as root
* Tue Aug 12 2003 mmj@suse.de
- Update to 1.0.16, with SSL/TLS support and many bugfixes
- Use new macros for stop/restart of services on rpm update/removal
* Sun Jul 27 2003 mmj@suse.de
- Support system quotas
* Tue Jun 17 2003 mmj@suse.de
- Update to version 1.0.15:
   A turkish translation has been added.
   Various functional and portability fixes have been made to the
  handling of upload scripts, to the pure-pw command and to the
  automatic creation of home directories.
   Accounts in a puredb database can now be quickly listed.
   The anonymous FTP directory can now be overriden on the Windows
  port (using a WIN32_ANON_DIR environment variable).
   The default banner has been stripped down to look more
  professionnal.
   Transfer speed on BSD systems has been improved.
   The license of the whole package has changed from GPL to a
  simplified BSD license.
* Thu May 15 2003 mmj@suse.de
- Allow dot-files in general, but prohibit writing of them [#26897]
* Wed Apr 30 2003 mmj@suse.de
- Apply the detach patch elsewhere to not break xinetd
- Add note to the xinetd conffile about the xinetd behaviour
- Rearrange the specfile a bit
* Thu Mar  6 2003 mmj@suse.de
- Fix the xinetd configuration file
* Fri Feb 28 2003 mmj@suse.de
- Add note to README.LDAP about use_ldap in the pam config
* Fri Jan 31 2003 mmj@suse.de
- Update to 1.0.14 and add a xinetd configuration file just in case
  the user wants to use it with xinetd. Default behaviour is still
  standalone.
* Mon Jan 20 2003 mmj@suse.de
- Added patch to detach from fd 0, 1 and 2 [#22836]
* Wed Nov 27 2002 mmj@suse.de
- Update to 1.0.13a which is a minor feature/bugfix-release
* Sat Oct  5 2002 ckm@suse.de
- Changed default config file to only allow ro anonymous logins,
  and tightened security in case writing is enabled.
* Sat Aug  3 2002 kukuk@suse.de
- Remove symlinks in postinstall script
- Add PreRequires for insserv
* Thu Jul  4 2002 kukuk@suse.de
- Update to version 1.0.12 (per-user limits)
* Fri Apr 26 2002 kukuk@suse.de
- Update to version 1.0.11 (minor bug fixes, better LDAP support)
* Mon Mar 11 2002 kukuk@suse.de
- Fix permissions
* Sat Feb 16 2002 kukuk@suse.de
- Fix print arguments [Bug #13389]
* Mon Feb 11 2002 ro@suse.de
- flgs in perl-config parser is an array
* Thu Jan 24 2002 kukuk@suse.de
- Update to version 1.0.8
- Compile with LDAP support
* Thu Nov 29 2001 kukuk@suse.de
- Add pam config file
- Cleanup example config file
* Thu Nov 22 2001 kukuk@suse.de
- Update to 1.0.3 (rename and quota fixes)
* Thu Nov  1 2001 kukuk@suse.de
- Initial release of a secure ftp server with LFS
